/**********************BST-V51ʵ鿪************************
*  ƽ̨BST-M51 + Keil U4 + STC89C52
*  ƣAD\DAģʵ(ʾ)
*  ˾ǲ޹˾       
*  ڣ2015-6
*  :11.0592MHZ
******************************************************************/
#include<reg52.h>    //ƬĴͷļ
#include <intrins.h> 
#include <string.h>
#include "NTC.h"

#define  AddWr 0x90    //PCF8591 ַ

// 
unsigned char AD_CHANNEL=0;
unsigned char  D[5] = {0x00};

sbit scl=P2^1;       //I2C  ʱ 
sbit sda=P2^0;       //I2C   
bit ack;                 /*Ӧ־λ*/

unsigned char date;
unsigned char SendData[64] = {0};
long g_NTC = 0;
/*******************************************************************
                     ߺ               
ԭ: void  Start_I2c();  
:     I2C,I2Cʼ.  
********************************************************************/
void Start_I2c()
{
  sda=1;         /*ʼź*/
  _nop_();
  scl=1;
  _nop_();        /*ʼʱ4.7us,ʱ*/
  _nop_();
  _nop_();
  _nop_();
  _nop_();    
  sda=0;         /*ʼź*/
  _nop_();        /* ʼʱ4s*/
  _nop_();
  _nop_();
  _nop_();
  _nop_();       
  scl=0;       /*ǯסI2Cߣ׼ͻ */
  _nop_();
  _nop_();
}

/*******************************************************************
                      ߺ               
ԭ: void  Stop_I2c();  
:     I2C,I2C.  
********************************************************************/
void Stop_I2c()
{
  sda=0;      /*ͽź*/
  _nop_();       /*ͽʱź*/
  scl=1;      /*ʱ4s*/
  _nop_();
  _nop_();
  _nop_();
  _nop_();
  _nop_();
  sda=1;      /*I2C߽ź*/
  _nop_();
  _nop_();
  _nop_();
  _nop_();
}

/*******************************************************************
                 ֽݷͺ               
ԭ: void  I2C_SendByte(UCHAR c);
:     cͳȥ,ǵַ,Ҳ,ȴӦ,
          ״̬λв.(ӦӦʹack=0)     
           ack=1; ack=0ʾӦ𻵡
********************************************************************/
void  I2C_SendByte(unsigned char  c)
{
 unsigned char  i;
 
 for(i=0;i<8;i++)  /*Ҫ͵ݳΪ8λ*/
    {
     if((c<<i)&0x80)sda=1;   /*жϷλ*/
       else  sda=0;                
     _nop_();
     scl=1;               /*ʱΪߣ֪ͨʼλ*/
      _nop_(); 
      _nop_();             /*֤ʱӸߵƽڴ4s*/
      _nop_();
      _nop_();
      _nop_();         
     scl=0; 
    }
    
    _nop_();
    _nop_();
    sda=1;                /*8λͷߣ׼Ӧλ*/
    _nop_();
    _nop_();   
    scl=1;
    _nop_();
    _nop_();
    _nop_();
    if(sda==1)ack=0;     
       else ack=1;        /*жǷյӦź*/
    scl=0;
    _nop_();
    _nop_();
}

/*******************************************************************
                 ֽݽպ               
ԭ: UCHAR  I2C_RcvByte();
:        մ,жߴ(Ӧź)
          ӦӦӻ  
********************************************************************/    
unsigned char   I2C_RcvByte()
{
  unsigned char  retc=0,i; 
  sda=1;                     /*Ϊ뷽ʽ*/
  for(i=0;i<8;i++)
      {
        _nop_();           
        scl=0;                  /*ʱΪͣ׼λ*/
        _nop_();
        _nop_();                 /*ʱӵ͵ƽڴ4.7s*/
        _nop_();
        _nop_();
        _nop_();
        scl=1;                  /*ʱΪʹЧ*/
        _nop_();
        _nop_();
        retc=retc<<1;
        if(sda==1)retc=retc+1;  /*λ,յλretc */
        _nop_();
        _nop_(); 
      }
  scl=0;    
  _nop_();
  _nop_();
  return(retc);
}

/********************************************************************
                     ӦӺ
ԭ:  void Ack_I2c(bit a);
:      Ӧź(ӦӦźţλa)
********************************************************************/
void Ack_I2c(bit a)
{  
  if(a==0)sda=0;              /*ڴ˷ӦӦź */
  else sda=1;				  /*0ΪӦ1ΪӦź */
  _nop_();
  _nop_();
  _nop_();      
  scl=1;
  _nop_();
  _nop_();                    /*ʱӵ͵ƽڴ4s*/
  _nop_();
  _nop_();
  _nop_();  
  scl=0;                     /*ʱߣסI2CԱ*/
  _nop_();
  _nop_();    
}

/************************************************************
*         : Pcf8591_DaConversion
*       : PCF8591ģ
*           : addrַchannelתͨvalueתֵ
*          	: 
******************* *****************************************/
bit Pcf8591_DaConversion(unsigned char addr,unsigned char channel,  unsigned char Val)
{
   Start_I2c();              //
   I2C_SendByte(addr);            //ַ
   if(ack==0)return(0);
   I2C_SendByte(0x40|channel);              //Ϳֽ
   if(ack==0)return(0);
   I2C_SendByte(Val);            //DACֵ  
   if(ack==0)return(0);
   Stop_I2c();               //
   return(1);
}

/************************************************************
*         : Pcf8591_SendByte
* 		: дһ
*           : addrַchannelתͨ
*          	: 
************************************************************/
bit PCF8591_SendByte(unsigned char addr,unsigned char channel)
{
   Start_I2c();              //
   I2C_SendByte(addr);            //ַ
   if(ack==0)return(0);
   I2C_SendByte(0x40|channel);              //Ϳֽ
   if(ack==0)return(0);
   Stop_I2c();               //
   return(1);
}

/************************************************************
*        	: PCF8591_RcvByte
*    	: ȡһתֵ
*           :
*           : dat
************************************************************/
unsigned char PCF8591_RcvByte(unsigned char addr)
{  
   unsigned char dat;

   Start_I2c();          //
   I2C_SendByte(addr+1);      //ַ
   if(ack==0)return(0);
   dat=I2C_RcvByte();          //ȡ0

   Ack_I2c(1);           //ͷӦź
   Stop_I2c();           //
   return(dat);
}
/*------------------------------------------------
                 ڳʼ
------------------------------------------------*/
void init_com(void)
{
	EA=1;        //ж
	ES=1;        //ж
	ET1=1;        //ʱT1ж
	TMOD=0x20;   //ʱT1ڷʽ2жϲ
	PCON=0x00;   //SMOD=0
	SCON=0x50;   // ʽ1 ɶʱ
	TH1=0xfd;    //Ϊ9600
	TL1=0xfd;
	TR1=1;       //ʱT1пƻ

}

//ڷͺ
void PutString(unsigned char *TXStr)  
{                
	ES=0;     
	while(*TXStr!=0) 
	{                      
	  SBUF=*TXStr;
	  while(TI==0);
	  TI=0;    
	  TXStr++;
	}
	ES=1; 
}
/*------------------------------------------------
                  ʱ
------------------------------------------------*/
void delay(unsigned char i)
{
  unsigned char j,k; 
  for(j=i;j>0;j--)
    for(k=125;k>0;k--);
}
/*------------------------------------------------
Ѷȡֵתһһַʾ
------------------------------------------------*/
void To_ascii(unsigned char num, unsigned char * buf, int pos)
{	
	 *(buf+pos) = num / 100 + '0';		   	   		  
	 *(buf+pos+1) = num /10 % 10 + '0';
	 *(buf+pos+2) = num % 10 + '0';

}
/*------------------------------------------------
                    
------------------------------------------------*/

/*㷽*/
/* 鿴 NTC-10K.doc ĵ洢 -10~50NTC.h
	ŷķɣ5/(1k+R) = V(AD) / R 
	V = AD/255*5
	 R = 1k*(AD/(255-AD))

*/

int NTC_GetTemp(int NTCReg)
{
	int i = 0;
	if(NTCReg >= NTC_table[0][1])
	{
		i = -10;
		return i;
	}
	else if(NTCReg <= NTC_table[60][1])
	{
		i = 50;
		return i;
	}
	for(i = 0; i < 61; i++)
	{
		if(NTCReg <= NTC_table[i][1] && NTCReg >= NTC_table[i+1][1])  /*ҵ*/
		{
			if((NTC_table[i][1] - NTCReg) >= (NTCReg - NTC_table[i+1][1]))  /*жĸֵȡĸ¶*/
			{
				i = NTC_table[i+1][0];
				return i;
			}
			else
			{
				i = NTC_table[i][0];
				return i;
			}
		}
	}
}
main()
{  
	init_com();
	while(1)
	{
	
		/********AD-DA*************/  
	
		PCF8591_SendByte(AddWr, 1);
		
		D[0]=PCF8591_RcvByte(AddWr);  //ADC0 ģת1      
			
		/********½ADֵͨڷͳȥ*************/
		
		
		/**/
		memset(SendData, 0x00, sizeof(SendData));
		memcpy(SendData, "$51,RMS", sizeof("$51,RMS"));
		To_ascii(D[0], SendData, 7);
		SendData[10] = ',';
		if(D[0] != 255)
		{
			g_NTC = ((float)D[0])/(255 - D[0]) * 10000;  //ֵ
			g_NTC = NTC_GetTemp(g_NTC);	        //¶ֵ
		}
		else
			g_NTC = 0xff;  //255ΪĬϳ
		
		SendData[11] = g_NTC / 1000 + '0';
		SendData[12] = g_NTC % 1000 / 100 + '0';
		SendData[13] = g_NTC % 100 /10 + '0';
		SendData[14] = g_NTC % 10 + '0';
		
		SendData[15] = '#';
		SendData[16] = 0x00;
		PutString(SendData);   
		
		delay(255);
		delay(255);
		delay(255);
		delay(255);
		
		delay(255);
		delay(255);
		delay(255);
		delay(255);
	 
   }
}