/**********************BST-M51ʵ鿪************************
*  ƽ̨BST-M51 + Keil U4 + STC89C52
*  ƣʵ
*  ˾ǲ޹˾       
*  ڣ2015-7
*  :11.0592MHZ
******************************************************************/
/**********************************ͷļ**********************************/
#include <reg52.h>
#include <string.h>
/************************************λ************************************/
sbit echo  = P2^0;                //ն˿
sbit trig = P2^1;                //˿

sbit wei1=P2^4;
sbit wei2=P2^5;
sbit wei3=P2^6;
sbit wei4=P2^7;
/************************************궨************************************/
#define dula P0		//ѡźŵ
#define uchar unsigned char
#define uint unsigned int
/****************************************************************/
long int distance=0;               //
uchar count;
unsigned char code table[]={0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,
                        0x07,0x7f,0x6f,0x77,0x7c,0x39,0x5e,0x79,0x71};
unsigned char code table1[]={0xbf,0x86,0xdb,0xcf,0xe6,0xed,0xfd,
                        0x87,0xff,0xef,0x71};

unsigned char SendData[32] = {0x00};  //ݰ
/******************************************************************************/
/*   : delay                                                      */
/*   : ʱ                                               */
/*   : ʱʱ䣨ms                                        */ 
/* ֵ    :                                                              */
/******************************************************************************/
void delay(unsigned int xms)				
{
	unsigned int i,j;
	for(i=xms;i>0;i--)		      //i=xmsʱԼxms
		for(j=112;j>0;j--);
}
/******************************************************************************/
/*   : display                                                      */
/*   : ʾ                                               */
/*   : Ծֵʮ                                        */ 
/* ֵ    :                                                              */
/******************************************************************************/
void display(long int num)			//ʾ
{
   uchar qian,bai,shi,ge;
   if((num>5000)||(num == 0))
   {
	   qian=15;//ֵΪλ
	   bai=15;
	   shi=10;
	   ge=15;
   }
   else
   {
	   qian=num/1000;//ֵΪλ
	   bai=(num/100)%10;//ֵΪʮλ
	   shi=(num/10)%10;//ֵΪλʾʱҪС
	   ge=num%10;//ֵΪСλѾ
   }
   wei1=1;		//ʾǧλ
   wei2=0;
   wei3=0;
   wei4=0;
   P0=table[qian];
   delay(2);

   wei1=0;		//ʾλ
   wei2=1;
   wei3=0;
   wei4=0;
   P0=table[bai];
   delay(2);

   wei1=0;		//ʾʮλ
   wei2=0;
   wei3=1;
   wei4=0;
   P0=table1[shi];
   delay(2);

   wei1=0;		//ʾλ
   wei2=0;
   wei3=0;
   wei4=1;
   P0=table[ge];
   delay(2);

}
/******************************************************************************/
/*   : Init_timer2                                                       */
/*   : ʼƬ                                               */
/*   :                                                              */
/*   :                                                              */
/* ֵ    :                                                              */
/******************************************************************************/
void Init_timer0(void)
{
	TMOD |= 0x01;	  //ʱ0ʼ,Ϊ16λԶװģʽ
 	TL0 = 0x66;
	TH0 = 0xfc;	      //1ms
    ET0 = 1;	      //ʱ2
	EA = 1;		      //жʹ
}
/******************************************************************************/
/*   : Init_Parameter                                                 */
/*   : ʼIOں                                           */
/*   :                                                              */
/*   :                                                              */
/* ֵ    :                                                              */
/******************************************************************************/
void Init_Parameter(void)
{
	 echo = 0;
	 trig = 0;
	 count = 0;
	 distance = 0;
}
/******************************************************************************/
/*   : Trig_SuperSonic                                                */
/*   :                                                    */
/*   :                                                              */
/*   :                                                              */
/* ֵ    :                                                              */
/******************************************************************************/
void Trig_SuperSonic(void)//
{
	 trig = 1;
	 delay(1);
	 trig = 0;
}
/******************************************************************************/
/*   : Measure_Distance                                               */
/*   : 뺯                                                   */
/*   :                                                              */
/*   :                                                              */
/* ֵ    :                                                              */
/******************************************************************************/
void Measure_Distance(void)
{
	uchar l;
	uint h,y;
	TR0 = 1;
	while(echo)
    {
        ;
    }	
	TR0 = 0;
	l = TL0;
	h = TH0;
	y = (h << 8) + l;
	y = y - 0xfc66;//us
	distance = y + 1000 * count;//ʱ (us)
	TL0 = 0x66;
	TH0 = 0xfc;
	delay(30);
	distance = 0.17 * distance;//
}
/******************************************************************************/
/*   : init_com                                                           */
/*   : ڳʼ                                                         */
/*   :                                                              */
/*   :                                                              */
/* ֵ    :                                                              */
/******************************************************************************/
void init_com(void)
{
	EA=1;        //ж
	ES=1;        //ж
	ET1=1;        //ʱT1ж
	TMOD|=0x20;   //ʱT1ڷʽ2жϲ
	PCON=0x00;   //SMOD=0
	SCON=0x50;   // ʽ1 ɶʱ
	TH1=0xfd;    //Ϊ9600
	TL1=0xfd;
	TR1=1;       //ʱT1п?

}

/******************************************************************************/
/*   : PutString                                                           */
/*   : ڷͺ                                                         */
/*   :                                                              */
/*   : charַ                                                             */
/* ֵ    :                                                              */
/******************************************************************************/
void PutString(unsigned char *TXStr)  
{                
	ES=0;     
	while(*TXStr!=0) 
	{                      
	  SBUF=*TXStr;
	  while(TI==0);
	  TI=0;    
	  TXStr++;
	}
	ES=1; 
}

/******************************************************************************/
/*   : main                                                           */
/*   :                                                          */
/*   :                                                              */
/*   :                                                              */
/* ֵ    :                                                              */
/******************************************************************************/					
void main(void)
{
 	uchar a;	
	init_com();
	Init_timer0();
	Init_Parameter();
	while(1)
	{
		Trig_SuperSonic();         //
		while(echo == 0)          //ȴ
		{
		 	;
		}
		Measure_Distance();        //תΪ
		for(a=100;a>0;a--)
		{   	
			display(distance);
		}
		//װͳλ
		memset(SendData, 0x00, sizeof(SendData));
		memcpy(SendData, "$51,CSB", sizeof("$51,CSB"));
	
		SendData[7] = distance / 1000 + '0';
		SendData[8] = distance % 1000 / 100 + '0';
		SendData[9] = distance % 100 / 10  + '0';
		SendData[10] = '.';
		SendData[11] = distance % 10 + '0';
		SendData[12] = '#';
		SendData[13] = 0x00;
		PutString(SendData);
	


		Init_Parameter();          // ³ʼ
	 }	
}
/******************************************************************************/
/*   : timer0                                                         */
/*   : T0жϴ                                                 */
/*   :                                                              */
/*   :                                                              */
/* ֵ    :                                                              */
/******************************************************************************/
void timer0 (void) interrupt 1
{
	TF0 = 0;
	TL0 = 0x66;
	TH0 = 0xfc;
	count++;
	if(count == 18)//18ms
	{
		TR0 =0;
		TL0 = 0x66;
		TH0 = 0xfc;
		count = 0;
	}
}
/******************************************************************************/
