
/**********************BST-V51ʵ鿪************************
*  ƽ̨BST-V51 + Keil U3 + STC89C52
*  ƣ12864ģʵ
*  ˾ǲܿƼ޹˾     
*  ڣ2013-11
*  :11.0592MHZ
*  ˵ѿԴṩԴ.
******************************************************************/
//12864ҺڳʱԱȶѾãûʹõʱܽſɲýκζʵΪ
//ݶ12864ҺԼҺԱȶȵڵλӿڵ·ûʹ׵12864ҺɲùҺĵ
//ܽվͿԡЩҺıȽϴûʹõʱɽҺĵ1920ŵıⲻӣ
//LCD12864ʵʱõUSBӿڹʱѹпܲLCD12864ʾ׻һ㣬һע//һ㣬5VֻϵĵԴӵϣлл⡣
#include <reg51.h>
#include <intrins.h>
#include <string.h>
#include "ds1302.h"
	
#define uchar unsigned char
#define uint  unsigned int
/*TS12864A-3 ˿ڶ*/
#define LCD_data  P0             //ݿ
sbit LCD_RS  =  P2^6;            //Ĵѡ 
sbit LCD_RW  =  P2^5;            //Һ/д
sbit LCD_EN  =  P2^7;            //Һʹܿ
sbit LCD_PSB =  P1^2;            ///ʽ
sbit wela    =  P2^6;
sbit dula    =  P2^7;

uchar code dis1[] = {"ǲܿƼ"};
uchar code dis2[] = {"51Ƭ"};
uchar code dis3[] = {"2017-05-11"};
uchar code dis4[] = {"22:25:36"};

#define delayNOP(); {_nop_();_nop_();_nop_();_nop_();};
uchar IRDIS[2];
uchar IRCOM[4];
void delay0(uchar x);  //x*0.14MS
void beep();
void  dataconv();
void lcd_pos(uchar X,uchar Y);  //ȷʾλ

/*Э鶨*/
bit startBit = 0;  				//ڽտʼ־λ
bit newLineReceived = 0; 		//һ֡Э
unsigned char inputString[50];  //Э
/*------------------------------------------------
                 ڳʼ
------------------------------------------------*/
void init_com(void)
{
   	SCON = 0x50; 	// SCON: ģʽ1, 8-bit UART, ʹܽ
	TMOD |= 0x20;
	TH1=0xfd; 		//9600 ֵ
	TL1=0xfd;
	TR1= 1;
	EA = 1;	    	//ж
	ES= 1; 			//򿪴ж

}

/*******************************************************************/
/*                                                                 */
/*  ʱ                                                       */
/*                                                                 */
/*******************************************************************/
void delay(int ms)
{
    while(ms--)
	{
      uchar i;
	  for(i=0;i<250;i++)  
	   {
	    _nop_();			   
		_nop_();
		_nop_();
		_nop_();
	   }
	}
}		
/*******************************************************************/
/*                                                                 */
/*LCDæ״̬                                                    */
/*lcd_busyΪ1ʱæȴlcd-busyΪ0ʱ,Удָݡ      */
/*                                                                 */
/*******************************************************************/
bit lcd_busy()
 {                          
    bit result;
    LCD_RS = 0;
    LCD_RW = 1;
    LCD_EN = 1;
    delayNOP();
    result = (bit)(P0&0x80);
    LCD_EN = 0;
    return(result); 
 }
/*******************************************************************/
/*                                                                 */
/*дָݵLCD                                                  */
/*RS=LRW=LE=壬D0-D7=ָ롣                             */
/*                                                                 */
/*******************************************************************/
void lcd_wcmd(uchar cmd)
{                          
   while(lcd_busy());
    LCD_RS = 0;
    LCD_RW = 0;
    LCD_EN = 0;
    _nop_();
    _nop_(); 
    P0 = cmd;
    delayNOP();
    LCD_EN = 1;
    delayNOP();
    LCD_EN = 0;  
}
/*******************************************************************/
/*                                                                 */
/*дʾݵLCD                                                  */
/*RS=HRW=LE=壬D0-D7=ݡ                               */
/*                                                                 */
/*******************************************************************/
void lcd_wdat(uchar dat)
{                          
   while(lcd_busy());
    LCD_RS = 1;
    LCD_RW = 0;
    LCD_EN = 0;
    P0 = dat;
    delayNOP();
    LCD_EN = 1;
    delayNOP();
    LCD_EN = 0; 
}
void lcd_display_str(int posX, int posY, unsigned char *str)
{
	int i = 0;
	lcd_pos(posX, posY);             //ʾλΪһеĵ1ַ
    while(str[i] != '\0')
	{                         //ʾַ
		lcd_wdat(str[i]);
		i++;
	}	
}
/*******************************************************************/
/*                                                                 */
/*  LCDʼ趨                                                  */
/*                                                                 */
/*******************************************************************/
void lcd_init()
{ 

    LCD_PSB = 1;         //ڷʽ
    
    lcd_wcmd(0x34);      //ָ
    delay(5);
    lcd_wcmd(0x30);      //ָ
    delay(5);
    lcd_wcmd(0x0C);      //ʾع
    delay(5);
    lcd_wcmd(0x01);      //LCDʾ
    delay(5);
}
/*********************************************************/
/*														 */
/*            									 */
/*                                                       */
/*********************************************************/
  main()
 {
    uchar i;
	uchar read_year, read_month, read_day, read_hour, read_minute, read_seconds;
	SYSTEMTIME CurrentTime;
	init_com();  //ʼ
    delay(10);                 //ʱ
    wela=0;
	dula=0; 
    lcd_init();                //ʼLCD   
	lcd_display_str(0, 0, dis1);
	lcd_display_str(1, 0, dis2);
	lcd_display_str(2, 0, dis3);
	lcd_display_str(3, 0, dis4);
	 
	Initial_DS1302();
	DS1302_SetTime(DS1302_HOUR,10);	//õʱ170530
	DS1302_SetTime(DS1302_MINUTE,31);
	DS1302_SetTime(DS1302_SECOND,30);   
	DS1302_SetTime(DS1302_YEAR,17);	//õʱ170530
	DS1302_SetTime(DS1302_MONTH,5);
	DS1302_SetTime(DS1302_DAY,20);            
  	while(1)
	{
		DS1302_GetTime(&CurrentTime);
		DateToStr(&CurrentTime);
		TimeToStr(&CurrentTime);
		lcd_display_str(2, 1, CurrentTime.DateString);
		lcd_display_str(3, 0, CurrentTime.TimeString);


		//ʼЭ $51,TIME3,20170520110156#
		while (newLineReceived)  //Эݽһ
		{
			//жǷ51Э
			if(inputString[1] != '5' || inputString[2] != '1')
			{
			 	newLineReceived = 0;  
		   		memset(inputString, 0x00, sizeof(inputString)); 
				break; 
			}
			//жǷʱõЭ
		 	if(inputString[4] != 'T' || inputString[5] != 'I' || inputString[6] != 'M' || inputString[7] != 'E')
			{
				newLineReceived = 0;  
	   			memset(inputString, 0x00, sizeof(inputString)); 
				break;	
			}
			//жǷ12864ʾ
			if(inputString[8] != '3')
			{
				newLineReceived = 0;  
	   			memset(inputString, 0x00, sizeof(inputString)); 
				break;
			}

			//ʼȡ  λ12 ʼ  $51,TIME1,20170520110156#
			read_year = (inputString[12] - 0x30)*10 + (inputString[13] - 0x30);
			read_month = (inputString[14] - 0x30)*10 + (inputString[15] - 0x30);
			read_day = (inputString[16] - 0x30)*10 + (inputString[17] - 0x30);
			
			read_hour = (inputString[18] - 0x30)*10 + (inputString[19] - 0x30);
			read_minute = (inputString[20] - 0x30)*10 + (inputString[21] - 0x30);
			read_seconds = (inputString[22] - 0x30)*10 + (inputString[23] - 0x30);
			
			DS1302_SetTime(DS1302_YEAR,read_year);	//õʱ170530
			DS1302_SetTime(DS1302_MONTH,read_month);
			DS1302_SetTime(DS1302_DAY,read_day);  
			DS1302_SetTime(DS1302_HOUR,read_hour);	//õʱ170530
			DS1302_SetTime(DS1302_MINUTE,read_minute);
			DS1302_SetTime(DS1302_SECOND,read_seconds);   

		 	newLineReceived = 0;  
	   		memset(inputString, 0x00, sizeof(inputString)); 
			break;
		}
	
	}
    
}



/*********************************************************/
/*														 */
/* ʱx*0.14msӳ									 */
/*                                                       */
/*********************************************************/

void delay0(uchar x)    //x*0.14MS
{
  uchar i;
  while(x--)
 {
  for (i = 0; i<13; i++) {}
 }
}
/*********************************************************/
/*                                                       */
/* 趨ʾλ                                          */
/*                                                       */
/*********************************************************/
void lcd_pos(uchar X,uchar Y)
{                          
   uchar  pos;
   if (X==0)
     {X=0x80;}
   else if (X==1)
     {X=0x90;}
   else if (X==2)
     {X=0x88;}
   else if (X==3)
     {X=0x98;}
   pos = X+Y ;  
   lcd_wcmd(pos);     //ʾַ
}


/******************************************************************/
/* жϳ*/
/******************************************************************/
void UART_SER () interrupt 4
{
	unsigned char n; 	//ʱ
	static int num = 0;

	if(RI) 		//жǽжϲ
	{
		RI = 0; 	//־λ
		n = SBUF; //뻺ֵ

		//control=n;
	    if(n == '$')
	    {
	      startBit = 1;
		  num = 0;
	    }
	    if(startBit == 1)
	    {
	       inputString[num] = n; 
		   num++;    
	    }  
	    if (startBit == 1 && n == '#') 
	    {
	       newLineReceived = 1; 
	       startBit = 0;
		   num = 0;
	    }
		
		if(num >= 50)
		{
			num = 0;
			startBit = 0;
			newLineReceived	= 0;
		}
	}

}
